stages:
  - process_issues
  - update_labels

process_issues:
  stage: process_issues
  variables:
    TEMPLATE_LABEL: "init::template"
    WORKING_REPO: "https://gitlab.com/chloe-demos/open-scripts/template-saving"
    WORKING_DIR: "template-saving"
    WORKING_BRANCH: "main"
  before_script:
    - apt-get update
    - apt-get install -y jq
    - jq --version
    - git config --global user.email "$EMAIL"
    - git config --global user.name "$USER_NAME"
  script:
    - |
      if [ -d "$WORKING_DIR" ]; then
        cd "$WORKING_DIR"
        git branch -M "$WORKING_BRANCH"
        git pull >> /dev/stdout 2>&1
      else
        git clone "$WORKING_REPO"
      fi
    - |
      ISSUES=$(curl --header "PRIVATE-TOKEN: $PRIVATE_TOKEN" --url "$CI_API_V4_URL/projects/$CI_PROJECT_ID/issues?labels=$TEMPLATE_LABEL")
      for issue in $(echo "$ISSUES" | jq -r '.[] | @base64'); do
         _jq() {
            echo ${issue} | base64 --decode | jq -r ${1}
        }
        issue_id=$(_jq '.id')
        echo $issue_id
        DESCRIPTION=$(_jq '.description')
        touch ".gitlab/issue_templates/new_template.md"
        echo "Showing description $DESCRIPTION"
        echo "$DESCRIPTION" > .gitlab/issue_templates/new_template.md
        git remote add gitlab_origin https://oauth2:$ACCESS_TOKEN@gitlab.com/chloe-demos/open-scripts/template-saving.git
        git checkout main
        git add .
        git commit -m "Add issue template"
        git push gitlab_origin HEAD:main -o ci.skip
      done

.update_labels:
  stage: update_labels
  image: node:latest
  script: 
    - npm install axios  
    - node update-labels.js  
